## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## Implementaion of miscellaneous game functions

import CvUtil
from CvPythonExtensions import *

# globals
gc = CyGlobalContext()

class CvGameUtils:
	"Miscellaneous game functions"
	def __init__(self): 
		pass
	
	def isVictoryTest(self):
		if ( gc.getGame().getElapsedGameTurns() > 10 ):
			return True
		else:
			return False

	def isPlayerResearch(self, argsList):
		ePlayer = argsList[0]
		return True

	def createBarbarianCities(self):
		return False
		
	def createBarbarianUnits(self):
		return False
		
	def skipResearchPopup(self,argsList):
		ePlayer = argsList[0]
		return False
		
	def showTechChooserButton(self,argsList):
		ePlayer = argsList[0]
		return True

	def getFirstRecommendedTech(self,argsList):
		ePlayer = argsList[0]
		return TechTypes.NO_TECH

	def getSecondRecommendedTech(self,argsList):
		ePlayer = argsList[0]
		eFirstTech = argsList[1]
		return TechTypes.NO_TECH

	def skipProductionPopup(self,argsList):
		pCity = argsList[0]
		return False
		
	def showExamineCityButton(self,argsList):
		pCity = argsList[0]
		return True

	def getRecommendedUnit(self,argsList):
		pCity = argsList[0]
		return UnitTypes.NO_UNIT

	def getRecommendedBuilding(self,argsList):
		pCity = argsList[0]
		return BuildingTypes.NO_BUILDING

	def updateColoredPlots(self):
		return False

	def isActionRecommended(self,argsList):
		pUnit = argsList[0]
		iAction = argsList[1]
		return False

	def cannotHandleAction(self,argsList):
		pPlot = argsList[0]
		iAction = argsList[1]
		bTestVisible = argsList[2]
		return False

	def cannotSelectionListMove(self,argsList):
		pPlot = argsList[0]
		bAlt = argsList[1]
		bShift = argsList[2]
		bCtrl = argsList[3]
		return False

	def cannotSelectionListGameNetMessage(self,argsList):
		eMessage = argsList[0]
		iData2 = argsList[1]
		iData3 = argsList[2]
		iData4 = argsList[3]
		iFlags = argsList[4]
		bAlt = argsList[5]
		bShift = argsList[6]
		return False

	def cannotDoControl(self,argsList):
		eControl = argsList[0]
		return False

	def canResearch(self,argsList):
		ePlayer = argsList[0]
		eTech = argsList[1]
		bTrade = argsList[2]
		return False

	def cannotResearch(self,argsList):
		ePlayer = argsList[0]
		eTech = argsList[1]
		bTrade = argsList[2]
		return False

	def canDoCivic(self,argsList):
		ePlayer = argsList[0]
		eCivic = argsList[1]
		
		return False

	def cannotDoCivic(self,argsList):
		ePlayer = argsList[0]
		eCivic = argsList[1]

		currentIdeology = gc.getPlayer(ePlayer).getStateReligion()

#Reactionary Limits----------------------------------------------
		#Const.Mon
		if ( currentIdeology == 0 ) and (eCivic == 1) and (gc.getPlayer(ePlayer).getCivics(0) <> 1):
			return True
		#Demo
		if ( currentIdeology == 0 ) and (eCivic == 2) and (gc.getPlayer(ePlayer).getCivics(0) <> 2):
			return True
		#Prol. Dict.
		if ( currentIdeology == 0 ) and (eCivic == 4) and (gc.getPlayer(ePlayer).getCivics(0) <> 4):
			return True
		#L-F
		if ( currentIdeology == 0 ) and (eCivic == 6) and (gc.getPlayer(ePlayer).getCivics(1) <> 6):
			return True
		#Planned
		if ( currentIdeology == 0 ) and (eCivic == 8) and (gc.getPlayer(ePlayer).getCivics(1) <> 8):
			return True
		#Freedom
		if ( currentIdeology == 0 ) and (eCivic == 11) and (gc.getPlayer(ePlayer).getCivics(2) <> 11):
			return True
		#Equality
		if ( currentIdeology == 0 ) and (eCivic == 12) and (gc.getPlayer(ePlayer).getCivics(2) <> 12):
			return True
		#MachinePolitics
		if ( currentIdeology == 0 ) and (eCivic == 17) and (gc.getPlayer(ePlayer).getCivics(3) <> 17):
			return True
		#Populism
		if ( currentIdeology == 0 ) and (eCivic == 18) and (gc.getPlayer(ePlayer).getCivics(3) <> 18):
			return True
		#Secularism
		if ( currentIdeology == 0 ) and (eCivic == 22) and (gc.getPlayer(ePlayer).getCivics(4) <> 22):
			return True
		#Atheism
		if ( currentIdeology == 0 ) and (eCivic == 24) and (gc.getPlayer(ePlayer).getCivics(4) <> 24):
			return True

#Conservative Limits-----------------------------------------------
		#Abs Mon
		if ( currentIdeology == 1 ) and (eCivic == 0) and (gc.getPlayer(ePlayer).getCivics(0) <> 0):
			return True
		#Democracy
		if ( currentIdeology == 1 ) and (eCivic == 2) and (gc.getPlayer(ePlayer).getCivics(0) <> 2):
			return True
		#Proletarian Dictatorship
		if ( currentIdeology == 1 ) and (eCivic == 4) and (gc.getPlayer(ePlayer).getCivics(0) <> 4):
			return True
		#Planned
		if ( currentIdeology == 1 ) and (eCivic == 8) and (gc.getPlayer(ePlayer).getCivics(1) <> 8):
			return True
		#Equality
		if ( currentIdeology == 1 ) and (eCivic == 12) and (gc.getPlayer(ePlayer).getCivics(2) <> 12):
			return True
		#Rule by Decree
		if ( currentIdeology == 1 ) and (eCivic == 15) and (gc.getPlayer(ePlayer).getCivics(3) <> 15):
			return True
		#Populism
		if ( currentIdeology == 1 ) and (eCivic == 18) and (gc.getPlayer(ePlayer).getCivics(3) <> 18):
			return True
		#Utopianism
		if ( currentIdeology == 1 ) and (eCivic == 19) and (gc.getPlayer(ePlayer).getCivics(3) <> 19):
			return True
		#Secularism
		if ( currentIdeology == 1 ) and (eCivic == 22) and (gc.getPlayer(ePlayer).getCivics(4) <> 22):
			return True
		#Atheism
		if ( currentIdeology == 1 ) and (eCivic == 24) and (gc.getPlayer(ePlayer).getCivics(4) <> 24):
			return True
		    
#Liberal Limits----------------------------------------------------
		#Abs Mon
		if ( currentIdeology == 2 ) and (eCivic == 0) and (gc.getPlayer(ePlayer).getCivics(0) <> 0):
			return True
		#Proletarian Dictatorship
		if ( currentIdeology == 2 ) and (eCivic == 4) and (gc.getPlayer(ePlayer).getCivics(0) <> 4):
			return True
		#Mercantilism
		if ( currentIdeology == 2 ) and (eCivic == 5) and (gc.getPlayer(ePlayer).getCivics(1) <> 5):
			return True
		#State Regulation
		if ( currentIdeology == 2 ) and (eCivic == 7) and (gc.getPlayer(ePlayer).getCivics(1) <> 7):
			return True
		#Planned Economy
		if ( currentIdeology == 2 ) and (eCivic == 8) and (gc.getPlayer(ePlayer).getCivics(1) <> 8):
			return True
		#Equality
		if ( currentIdeology == 2 ) and (eCivic == 12) and (gc.getPlayer(ePlayer).getCivics(2) <> 12):
			return True
		#Rule by Decree
		if ( currentIdeology == 2 ) and (eCivic == 15) and (gc.getPlayer(ePlayer).getCivics(3) <> 15):
			return True
		#Utopianism
		if ( currentIdeology == 2 ) and (eCivic == 19) and (gc.getPlayer(ePlayer).getCivics(3) <> 19):
			return True
		#Religious Supremacy
		if ( currentIdeology == 2 ) and (eCivic == 20) and (gc.getPlayer(ePlayer).getCivics(4) <> 20):
			return True
		#Romanticism
		if ( currentIdeology == 2 ) and (eCivic == 21) and (gc.getPlayer(ePlayer).getCivics(4) <> 21):
			return True

#Socialist Limits--------------------------------------------------
		#Absolute Monarchy
		if ( currentIdeology == 3 ) and (eCivic == 0) and (gc.getPlayer(ePlayer).getCivics(0) <> 0):
			return True
		#Const.Mon
		if ( currentIdeology == 3 ) and (eCivic == 1) and (gc.getPlayer(ePlayer).getCivics(0) <> 1):
			return True
		#Mercantilism
		if ( currentIdeology == 3 ) and (eCivic == 5) and (gc.getPlayer(ePlayer).getCivics(1) <> 5):
			return True
		#Laissez-Faire
		if ( currentIdeology == 3 ) and (eCivic == 6) and (gc.getPlayer(ePlayer).getCivics(1) <> 6):
			return True
		#Indv. Freedom
		if ( currentIdeology == 3 ) and (eCivic == 11) and (gc.getPlayer(ePlayer).getCivics(2) <> 11):
			return True
		#Imperialism
		if ( currentIdeology == 3 ) and (eCivic == 14) and (gc.getPlayer(ePlayer).getCivics(2) <> 14):
			return True
		#Rule by Decree
		if ( currentIdeology == 3 ) and (eCivic == 15) and (gc.getPlayer(ePlayer).getCivics(3) <> 15):
			return True
		#Utopianism
		if ( currentIdeology == 3 ) and (eCivic == 19) and (gc.getPlayer(ePlayer).getCivics(3) <> 19):
			return True
		#Religious Supremacy
		if ( currentIdeology == 3 ) and (eCivic == 20) and (gc.getPlayer(ePlayer).getCivics(4) <> 20):
			return True
		#Romanticism
		if ( currentIdeology == 3 ) and (eCivic == 21) and (gc.getPlayer(ePlayer).getCivics(4) <> 21):
			return True

#Communist Limits--------------------------------------------------
		#Abs Monarh
		if ( currentIdeology == 4 ) and (eCivic == 0) and (gc.getPlayer(ePlayer).getCivics(0) <> 0):
			return True
		#Con Mon
		if ( currentIdeology == 4 ) and (eCivic == 1) and (gc.getPlayer(ePlayer).getCivics(0) <> 1):
			return True
		#Dem
		if ( currentIdeology == 4 ) and (eCivic == 2) and (gc.getPlayer(ePlayer).getCivics(0) <> 2):
			return True
		#Merc
		if ( currentIdeology == 4 ) and (eCivic == 5) and (gc.getPlayer(ePlayer).getCivics(1) <> 5):
			return True
		#L-F
		if ( currentIdeology == 4 ) and (eCivic == 6) and (gc.getPlayer(ePlayer).getCivics(1) <> 6):
			return True
		#StateReg
		if ( currentIdeology == 4 ) and (eCivic == 7) and (gc.getPlayer(ePlayer).getCivics(1) <> 7):
			return True
		#Indv. Freedom
		if ( currentIdeology == 4 ) and (eCivic == 11) and (gc.getPlayer(ePlayer).getCivics(2) <> 11):
			return True
		#Nationalism
		if ( currentIdeology == 4 ) and (eCivic == 13) and (gc.getPlayer(ePlayer).getCivics(2) <> 13):
			return True
		#Imperialism
		if ( currentIdeology == 4 ) and (eCivic == 14) and (gc.getPlayer(ePlayer).getCivics(2) <> 14):
			return True
		#Religious Sup
		if ( currentIdeology == 4 ) and (eCivic == 20) and (gc.getPlayer(ePlayer).getCivics(4) <> 20):
			return True
		#Romanticism
		if ( currentIdeology == 4 ) and (eCivic == 21) and (gc.getPlayer(ePlayer).getCivics(4) <> 21):
			return True

		return False
		
	def canTrain(self,argsList):
		pCity = argsList[0]
		eUnit = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		return False

	def cannotTrain(self,argsList):
		pCity = argsList[0]
		eUnit = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		return False

	def canConstruct(self,argsList):
		pCity = argsList[0]
		eBuilding = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		bIgnoreCost = argsList[4]
		return False

	def cannotConstruct(self,argsList):
		pCity = argsList[0]
		eBuilding = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		bIgnoreCost = argsList[4]
		return False

	def canCreate(self,argsList):
		pCity = argsList[0]
		eProject = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		return False

	def cannotCreate(self,argsList):
		pCity = argsList[0]
		eProject = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		return False

	def canMaintain(self,argsList):
		pCity = argsList[0]
		eProcess = argsList[1]
		bContinue = argsList[2]
		return False

	def cannotMaintain(self,argsList):
		pCity = argsList[0]
		eProcess = argsList[1]
		bContinue = argsList[2]
		return False

	def AI_chooseTech(self,argsList):
		ePlayer = argsList[0]
		bFree = argsList[1]
		return TechTypes.NO_TECH

	def AI_chooseProduction(self,argsList):
		pCity = argsList[0]
		return False

	def AI_unitUpdate(self,argsList):
		pUnit = argsList[0]
		return False

	def AI_doWar(self,argsList):
		eTeam = argsList[0]
		return False

	def AI_doDiplo(self,argsList):
		ePlayer = argsList[0]
		return False

	def calculateScore(self,argsList):
		ePlayer = argsList[0]
		bFinal = argsList[1]
		bVictory = argsList[2]
		
		iPopulationScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getPopScore(), gc.getGame().getInitPopulation(), gc.getGame().getMaxPopulation(), gc.getDefineINT("SCORE_POPULATION_FACTOR"), True, bFinal, bVictory)
		iLandScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getLandScore(), gc.getGame().getInitLand(), gc.getGame().getMaxLand(), gc.getDefineINT("SCORE_LAND_FACTOR"), True, bFinal, bVictory)
		iTechScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getTechScore(), gc.getGame().getInitTech(), gc.getGame().getMaxTech(), gc.getDefineINT("SCORE_TECH_FACTOR"), True, bFinal, bVictory)
		iWondersScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getWondersScore(), gc.getGame().getInitWonders(), gc.getGame().getMaxWonders(), gc.getDefineINT("SCORE_WONDER_FACTOR"), False, bFinal, bVictory)
		return int(iPopulationScore + iLandScore + iWondersScore + iTechScore)

	def doHolyCity(self):
		return False

	def doHolyCityTech(self,argsList):
		eTeam = argsList[0]
		ePlayer = argsList[1]
		eTech = argsList[2]
		bFirst = argsList[3]
		return False

	def doGold(self,argsList):
		ePlayer = argsList[0]
		return False

	def doResearch(self,argsList):
		ePlayer = argsList[0]
		return False

	def doGoody(self,argsList):
		ePlayer = argsList[0]
		pPlot = argsList[1]
		pUnit = argsList[2]
		return False

	def doGrowth(self,argsList):
		pCity = argsList[0]
		return False

	def doProduction(self,argsList):
		pCity = argsList[0]
		return False

	def doCulture(self,argsList):
		pCity = argsList[0]
		return False

	def doPlotCulture(self,argsList):
		pCity = argsList[0]
		bUpdate = argsList[1]
		return False

	def doReligion(self,argsList):
		pCity = argsList[0]
		return False

	def doGreatPeople(self,argsList):
		pCity = argsList[0]
		return False

	def doMeltdown(self,argsList):
		pCity = argsList[0]
		return False
