# Greek World Scenario

from CvPythonExtensions import *
import CvUtil
import PyHelpers		# LOQ
import Popup
import pickle			# LOQ 2005-10-12

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer	# LOQ

### Constants ###


# initialise player variables to player IDs from WBS
iAragon = 0
iCastile = 1
iDenmark = 2
iEngland = 3
iFrance = 4
iHungary = 5
iJerusalem = 6
iPoland = 7
iTheTurks = 8
iAlmoravid = 9
iBalticPagans = 10
iByzantine = 11
iHRE = 12
iKiev = 13
iMongols = 14
iPapalStates = 15
iSaracens = 16
iTeutonicOrder = 17
iBarbarian = 18

iNumPlayers = 18

pAragon = gc.getPlayer(iAragon)
pCastile = gc.getPlayer(iCastile)
pDenmark = gc.getPlayer(iDenmark)
pEngland = gc.getPlayer(iEngland)
pFrance = gc.getPlayer(iFrance)
pHungary = gc.getPlayer(iHungary)
pJerusalem = gc.getPlayer(iJerusalem)
pPoland = gc.getPlayer(iPoland)
pMongols = gc.getPlayer(iMongols)
pBalticPagans = gc.getPlayer(iBalticPagans)
pTheTurks = gc.getPlayer(iTheTurks)
pAlmoravid = gc.getPlayer(iAlmoravid)
pSaracens = gc.getPlayer(iSaracens)
pByzantine = gc.getPlayer(iByzantine)
pHRE = gc.getPlayer(iHRE)
pKiev = gc.getPlayer(iKiev)
pPapalStates = gc.getPlayer(iPapalStates)
pTeutonicOrder = gc.getPlayer(iTeutonicOrder)

class ThroneAndAltar:

        def eventpopup(self, titletext, eventtext, eventart):                
                #Displays the event popup - ArbitraryGuy
                popup = Popup.PyPopup()
                popup.setPosition(300, 100)
                popup.addDDS(eventart, 320, 120, 256, 256)
                popup.addSeparator()
                popup.setHeaderString( titletext )
                popup.setBodyString( eventtext )                
                popup.launch()


        def getRand(self, iNum):
		#Get a random number, ripped from Trip's Rebellion Mod
                return CyGame().getSorenRandNum(iNum, "Throne and Altar")
        
        def makeUnit(self, iUnit, iPlayer, tCoords, iNum): #by LOQ
                #Make a unit at tCoords, ripped from GreekWorld Mod
                for i in range(iNum):
                        player = gc.getPlayer(iPlayer)
                        player.initUnit(iUnit, tCoords[0], tCoords[1], UnitAITypes.NO_UNITAI)

        def makeUnitCapital(self, iUnit, iPlayer, iNum):
                #Make units at iPlayer's capital city - ArbitraryGuy
                CX = gc.getPlayer(iPlayer).getCapitalCity().getX()
                CY = gc.getPlayer(iPlayer).getCapitalCity().getY()
                for i in range(iNum):
                        player = gc.getPlayer(iPlayer)
                        player.initUnit(iUnit, CX, CY, UnitAITypes.NO_UNITAI)

        def checkTurn(self, iGameTurn):
                #On every turn, even conditions will be checked - This is all by ArbitraryGuy
                iGameYear = 1834 + iGameTurn

                if (iGameTurn == 1):
                        self.eventpopup("Second Turn","Aren't you happy now?","Art/interface/screens/events/event_teutonic.dds") 

                if (iGameTurn == 2):
                        CyGame().setActivePlayer( 4, True)
                        

